package com.zhili.stationserver.annotation;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

@Retention(RetentionPolicy.RUNTIME)
@Target({ElementType.FIELD})
public @interface TransformField {
    //从第几个字节开始
    int start();
    //占多少字节
    int length() default 1;
    //数据类型->StationCloudCommunicator.TransformType.xxx
    String type();
    //only apply if float, int((x-offset)/accuracy)
    float accuracy() default 1f;
    float offset() default 0f;
    int intDefault() default -1;
    float floatDefault() default -255f;
    //float保留几位小数
    int floatSignificant() default 2;
    int segmentLen() default 0;
}
