package com.zhili.stationserver.dto;

import com.zhili.stationserver.annotation.ProtocalTranform;
import com.zhili.stationserver.annotation.TransformField;
import lombok.Data;

import java.util.Date;
import java.util.List;

import static com.zhili.stationserver.constant.TransformType.*;

/**
 * @author zhaoyuanqi
 */
@Data
@ProtocalTranform(command = StationMessage.CommandType.PERCEPTION_CHARGE_RECORD, size = 878)
public class PerceptionChargeRecordDto {
    String stationCode;
    @TransformField(start = 0, type = DATE_TYPE)
    Date time;
    @TransformField(start = 8, type = UINT_TYPE)
    Integer chargerId;
    @TransformField(start = 9, type = UINT_TYPE)
    Integer gunNo;
    @TransformField(start = 10, type = STRING_TYPE, length = 32)
    String serialNo;
    @TransformField(start = 42, type = STRING_TYPE, length = 17)
    String vin;
    @TransformField(start = 59, type = UINT_TYPE, length = 2)
    Integer driverId;
    @TransformField(start = 61, type = STRING_TYPE, length = 13)
    String exchangeNo;
    @TransformField(start = 74, type = TIME_STRING_TYPE)
    String startTime;
    @TransformField(start = 82, type = TIME_STRING_TYPE)
    String endTime;
    @TransformField(start = 90, type = UINT_TYPE, length = 4)
    Integer chgSec;
    @TransformField(start = 94, type = STRING_TYPE, length = 18)
    String sn;
    @TransformField(start = 112, type = UINT_TYPE)
    Integer startSoc;
    @TransformField(start = 113, type = UINT_TYPE)
    Integer endSoc;
    @TransformField(start = 114, type = FLOAT_TYPE, accuracy = 0.01f, length = 4)
    Float startPower;
    @TransformField(start = 118, type = FLOAT_TYPE, accuracy = 0.01f, length = 4)
    Float endPower;
    @TransformField(start = 122, type = FLOAT_TYPE, accuracy = 0.01f, length = 4)
    Float power;
    @TransformField(start = 126, type = UINT_TYPE, length = 2)
    Integer endReason;
    @TransformField(start = 128, type = FLOAT_TYPE, accuracy = 0.000001f, length = 4,floatSignificant = 6)
    Float money;
    @TransformField(start = 132, type = FLOAT_TYPE, accuracy = 0.000001f, length = 4,floatSignificant = 6)
    Float serMoney;
    @TransformField(start = 136, type = CHARGE_LIST_TYPE, length = 720, segmentLen = 15)
    List<ChargeDetailDto> chargeDetailList;
    @TransformField(start = 856, type = UINT_TYPE)
    Integer startSource;
    @TransformField(start = 857, type = UINT_TYPE)
    Integer chargeType;
    @TransformField(start = 858, type = UINT_TYPE, length = 2)
    Integer fleetId;
    @TransformField(start = 860, type = UINT_TYPE)
    Integer authResult;
    @TransformField(start = 861, type = STRING_TYPE,length = 17)
    String possibleVin;
    //service服务id 用来接收记录保存状态回传
    private String serviceInstanceId;

    //用来接收记录保存状态回传站控
    private String connIdStr;
}
