package com.zhili.stationserver.dto;


import com.alibaba.fastjson.JSON;
import com.zhili.stationserver.annotation.ProtocalTranform;
import com.zhili.stationserver.annotation.TransformField;
import lombok.Data;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import static com.zhili.stationserver.constant.TransformType.*;


/**
 * @author ：HuangBin
 * @description：TODO
 * @date ：2023/4/13 13:23
 */
@Data
@ProtocalTranform(command = StationMessage.CommandType.PERCEPTION_BAT_AVAILABLE, size = 11)
public class PerceptionUploadAvailableBatsDto {
    String stationCode;
    @TransformField(start = 0, type = DATE_TYPE)
    Date time;
    @TransformField(start = 8, type = UINT_TYPE)
    Integer posCnt;
    @TransformField(start = 9, type = BYTES_TYPE, length = 2)
    byte[] available;

    public List<Integer> getAvailablePoses() {
        List<Integer> l = new ArrayList<>();
        for (int i = 0; i < available.length; i++) {
            byte by = available[i];
            for (int j = 0; j < 8; j++) {
                int mask = 0x01 << j;
                int masked = by & mask;
                if (mask == masked) {
                    l.add(i * 8 + j + 1);
                }
            }
        }
        return l;
    }

    public static void main(String[] args) {
        PerceptionUploadAvailableBatsDto dto = new PerceptionUploadAvailableBatsDto();
        byte[] bytes = new byte[2];
        bytes[0] = 7;
        dto.setAvailable(bytes);
        System.out.println(dto.getAvailablePoses());
        String s = JSON.toJSONString(dto);
        System.out.println(s);
    }
}
