package com.zhili.stationserver.dto;


import com.zhili.stationserver.annotation.ProtocalTranform;
import com.zhili.stationserver.annotation.TransformField;
import lombok.Data;
import lombok.NoArgsConstructor;

import static com.zhili.stationserver.constant.TransformType.STRING_TYPE;
import static com.zhili.stationserver.constant.TransformType.UINT_TYPE;

@Data
@ProtocalTranform(command = StationMessage.CommandType.START_EXCHANGE, size = 87)
@NoArgsConstructor
public class StartEventDTO {

    /*** 指令编号*/
    @TransformField(start = 0, type = STRING_TYPE, length = 32)
    String cmdNo;
    /*** 启动来源 0：站控，1：小程序*/
    @TransformField(start = 32, type = UINT_TYPE)
    int controlSource;
    @TransformField(start = 33, type = STRING_TYPE, length = 11)
    String driverId;
    @TransformField(start = 44, type = STRING_TYPE, length = 11)
    String mobile;
    @TransformField(start = 55, type = STRING_TYPE, length = 32)
    String name;
    /*** 车队名称*/
    String fleetName;
}